-- Well, here's a lot of logic mess that come mostly from Hotline Miami Combo Counter
-- Most of it have been cleaned and a lot of customization added
-- You can change assets mostly to get every effect you want
-- The only hardcoded stuff are the "stage" to trigger ranks (and their number)
-- and the ""animations"", which i don't like much but hey, it does the work so...

if not DMCCC then
	log("[DMCCC] Error: Failed to create Mod Options menu")
	return
end

Hooks:PostHook(HUDManager, "_setup_player_info_hud_pd2", "DMCCC_setup_player_info_hud_pd2", function(self, ...)
    self._hud_dmccc = HUD_DMCCC:new(managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2))
    self:add_updator("DMCCC_Updater", callback(self._hud_dmccc, self._hud_dmccc, "update"))
end)

function HUDManager:DMCCC_OnKillshot()
    self._hud_dmccc:OnKillshot()
end

HUD_DMCCC = HUD_DMCCC or class()
function HUD_DMCCC:init(hud)
    self._t = 0
    self._kill_time = 0
    self._kills = 0
    self._stage = 0
    self._hud_panel = hud.panel
    self._full_hud_panel = managers.hud._fullscreen_workspace:panel():gui(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2, {})
    self._combo_panel = self._full_hud_panel:panel({
        visible = false,
        name = "dmccc_combo_panel",
        x = 0,
        y = 0,
        valign = "top",
        blend_mode = "normal"
    })
    self._combo_icon = self._combo_panel:bitmap({
        name = "Combo_icon",
        visible = true,
        layer = 0,
        texture = "guis/textures/Rank_D",
        x = 0,
        w = DMCCC:GetOption("panel_w"),
        h = DMCCC:GetOption("panel_h"),
        vertical = "top"
    })
    self._combo_icon:set_left(self._full_hud_panel:left())
    self._combo_icon:set_top(DMCCC:GetOption("panel_y"))
    if blt.xaudio then
        blt.xaudio.setup()
	end
end

function HUD_DMCCC:set_combo(combo)
    if Utils:IsInHeist() and combo >= DMCCC:GetOption("rank_d_kills") then 
		self._combo_panel:set_visible(true)
	elseif Utils:IsInHeist() and combo < 1 and self._stage > 0 then
		self._stage = 0
		self._combo_icon:animate(callback(self, self, "close_anim"))
	elseif not Utils:IsInHeist() then
		self._combo_panel:set_visible(false)
	end
    if combo > 0 then
        if self._stage == 0 and combo >= DMCCC:GetOption("rank_d_kills") then
            self._combo_icon:set_image("guis/textures/Rank_D")
            self._combo_icon:animate(callback(self, self, "open_anim"))
            if DMCCC:GetOption("rank_sounds") then XAudio.UnitSource:new(XAudio.PLAYER, XAudio.Buffer:new(DMCCC._path .. "assets/snd/Rank_D.ogg")):set_volume(DMCCC:GetOption("rank_volume")) end
            self._stage = 1
        elseif self._stage == 1 and combo >= DMCCC:GetOption("rank_c_kills") then
            self._combo_icon:set_image("guis/textures/Rank_C")
            self._combo_icon:animate(callback(self, self, "open_anim"))
            if DMCCC:GetOption("rank_sounds") then XAudio.UnitSource:new(XAudio.PLAYER, XAudio.Buffer:new(DMCCC._path .. "assets/snd/Rank_C.ogg")):set_volume(DMCCC:GetOption("rank_volume")) end
            self._stage = 2
        elseif self._stage == 2 and combo >= DMCCC:GetOption("rank_b_kills") then
            self._combo_icon:set_image("guis/textures/Rank_B")
            self._combo_icon:animate(callback(self, self, "open_anim"))
            if DMCCC:GetOption("rank_sounds") then XAudio.UnitSource:new(XAudio.PLAYER, XAudio.Buffer:new(DMCCC._path .. "assets/snd/Rank_B.ogg")):set_volume(DMCCC:GetOption("rank_volume")) end
            self._stage = 3
        elseif self._stage == 3 and combo >= DMCCC:GetOption("rank_a_kills") then
            self._combo_icon:set_image("guis/textures/Rank_A")
            self._combo_icon:animate(callback(self, self, "open_anim"))
            if DMCCC:GetOption("rank_sounds") then XAudio.UnitSource:new(XAudio.PLAYER, XAudio.Buffer:new(DMCCC._path .. "assets/snd/Rank_A.ogg")):set_volume(DMCCC:GetOption("rank_volume")) end
            self._stage = 4
        elseif self._stage == 4 and combo >= DMCCC:GetOption("rank_s_kills") then
            self._combo_icon:set_image("guis/textures/Rank_S")
            self._combo_icon:animate(callback(self, self, "open_anim"))
            if DMCCC:GetOption("rank_sounds") then XAudio.UnitSource:new(XAudio.PLAYER, XAudio.Buffer:new(DMCCC._path .. "assets/snd/Rank_S.ogg")):set_volume(DMCCC:GetOption("rank_volume")) end
            self._stage = 5
        elseif self._stage == 5 and combo >= DMCCC:GetOption("rank_ss_kills") then
            self._combo_icon:set_image("guis/textures/Rank_SS")
            self._combo_icon:animate(callback(self, self, "open_anim"))
            if DMCCC:GetOption("rank_sounds") then XAudio.UnitSource:new(XAudio.PLAYER, XAudio.Buffer:new(DMCCC._path .. "assets/snd/Rank_SS.ogg")):set_volume(DMCCC:GetOption("rank_volume")) end
            self._stage = 6
        elseif self._stage == 6 and combo >= DMCCC:GetOption("rank_sss_kills") then
            self._combo_icon:set_image("guis/textures/Rank_SSS")
            self._combo_icon:animate(callback(self, self, "open_anim"))
            if DMCCC:GetOption("rank_sounds") then XAudio.UnitSource:new(XAudio.PLAYER, XAudio.Buffer:new(DMCCC._path .. "assets/snd/Rank_SSS.ogg")):set_volume(DMCCC:GetOption("rank_volume")) end
            self._stage = 7
        end
    end
end

function HUD_DMCCC:open_anim(panel)
    local panel_x = DMCCC:GetOption("panel_x")
    local panel_y = DMCCC:GetOption("panel_y")
    local speed = 75
    panel:set_x(panel_x-96)
    panel:set_top(panel_y)
    local TOTAL_T = 10/speed
    local t = TOTAL_T
    while t > 0 do
        local dt = coroutine.yield()
        t = t - dt
        panel:set_x(panel_x - 96 + (1 - t / TOTAL_T) * 96)
    end
end

function HUD_DMCCC:close_anim( panel )
    local panel_x = DMCCC:GetOption("panel_x")
    local panel_y = DMCCC:GetOption("panel_y")
	local speed = 150
	local TOTAL_T = 10/speed
	local t = TOTAL_T
	while t > 0 do
		local dt = coroutine.yield()
		t = t - dt
		panel:set_x(panel_x - (1 - t/TOTAL_T) * 200)
	end
	self._combo_panel:set_visible(false)
end

local time_buffer = DMCCC:GetOption("kill_timer")
function HUD_DMCCC:OnKillshot()
	self._combo_icon:set_w(DMCCC:GetOption("panel_w"))
	self._combo_icon:set_h(DMCCC:GetOption("panel_h"))
	time_buffer = DMCCC:GetOption("kill_timer")
    self._kills = self._kills + 1
    self._kill_time = self._t
end

function HUD_DMCCC:update(t, dt)
    self._t = t
    if (t - self._kill_time) > time_buffer then
        self._kills = 0
    end
    self:set_combo(self._kills)
end